//=================================================
//	 Steampunk Nixie Tube Clock 1.0
//	 Written by: Dean Beedell
//
//	 Dean.beedell@lightquick.co.uk
//	 Copyright (C) 2011 All Rights Reserved.
//=================================================

/*global clockTimer,
		 leftHourIndicator, rightHourIndicator,
		 leftMinuteIndicator, rightMinuteIndicator,
		 leftSecondIndicator, rightSecondIndicator
*/

/*properties getHours, getMinutes, getSeconds, hour24Pref, interval,
    length, secondsShowPref, soundOnPref, src, substring, ticking, value,
    visible, widthPref
*/

var mn, se, dt, mnth, yr,
	hour, mins, secs, date, month, year, am_pm,
	oldSecondsShowPref, oldWidthPref,

	zzzz = WidgetPath + "Resources/zzzz.wav",
        sparks = WidgetPath + "Resources/sparks.wav",
	relay = WidgetPath + "Resources/relay.wav",
	electricDrone = WidgetPath + "Resources/electricDrone.wav",
	shutdown = WidgetPath + "Resources/shutdown.wav",
        tingingSound = WidgetPath + "Resources/ting.wav",
	lock = WidgetPath + "Resources/lock.wav",
	winding = WidgetPath + "Resources/winding.wav",	
	buzzer = WidgetPath + "Resources/buzzer.wav";
	
	
        var oldleftHourIndicator = null,
	oldrightHourIndicator = null,
	oldleftMinuteIndicator = null,
	oldrightMinuteIndicator = null,
	oldleftSecondIndicator = null,
	oldrightSecondIndicator = null;

var windowPos = 0;

var size = 1,
         maxLength = 100,
         minLength = 10,
         ticks = 18
         Scale = 150;
var wsc=new ActiveXObject("WScript.Shell");
//==============================================================
// function called on the widget onload event
//=============================================================
function widgetOnLoad() {

        getPrefs();                       // set the preferences - required by Xwidget as it has no native prefs
        resize();                         // resize if required
        //nixiewidget.visible = true;
        setIndicatorFonts();


        mainScreen();

        setBgImage();
        createLicence();
        nixiewidget.visible=true;
        //Scale = Number(preferencesWidthPrefValue.percent+5) / 100;

        if (preferencesSecondsShowPrefValue.text != "disabled") {
        	oldleftSecondIndicator = leftSecondIndicator.src;
        	oldrightSecondIndicator = rightSecondIndicator.src;
        }
        if (preferencesSecondsShowPrefValue.text != "disabled") {
        	//widget.width  = 1500 ;
		leftSecondIndicator.visible = true;
                rightSecondIndicator.visible = true;
                bgimage5.visible = true;
                bgimage6.visible = true;
        } else {
        	print("invisi");
                //widget.width  = 800 ;
		leftSecondIndicator.visible = false;
                rightSecondIndicator.visible = false;
                bgimage5.visible = false;
                bgimage6.visible = false;
         }

	oldSecondsShowPref = preferencesSecondsShowPrefValue.text;
	oldWidthPref = preferencesWidthPrefValue.text;
	if (preferencessoundprefvalue.text != "disabled") {playSound(electricDrone)};


        //leftHourIndicator.visible = true;
        //bgimage1.visible = true;
        //rightHourIndicator.visible = true;
        //bgimage2.visible = true;
        //leftMinuteIndicator.visible = true;
        //bgimage3.visible = true;
        //rightMinuteIndicator.visible = true;
        //bgimage4.visible = true;

        /* set the widget lock status if pinned
        if (preferences.widgetLockPref.value === "1") {
    		widget.locked = true;
                    log ( "Setting the locking pin ",pin.left);
                    pin.opacity = 255;
    		pin.left = preferences.pinleftPref.value  ;
    		pin.top = preferences.pintopPref.value  ;
        }
        */
        updateTime();
}
//=====================
//End function
//=====================



//==============================================================
// function to return date and time values
//==============================================================
function returndateandtimevalues() {
	if (preferencesHour24PrefValue.text == "disabled") {
		// adjust hours from 24-hour time to 12 hour time
		if (hour === 0) {
			hour = 12;
			am_pm = 'am';
		} else if (hour < 12) {
			am_pm = 'am';
		} else if (hour === 12) {
			am_pm = 'pm';
		} else if (hour > 12) {
			am_pm = 'pm';
			hour = hour - 12;
		}
	}

	// normalise from variables to strings
	hour = String(hour);
	mins = String(mn);
	secs = String(se);
}
//=====================
//End function
//=====================


//==============================================================
// function to animate and update the nixie tube counters
//==============================================================
function updatecounters() {


	//determine which number to display on the hour
	if (hour.length < 2) {
		hour = "0" + hour;
	}

	setIndicatorFonts();
}
//=====================
//End function
//=====================

        function rattle(o) {
		o.visible = false;
		sleep(1);
		if (preferencesTenSecondTickSoundPrefValue.text != "disabled") {
                  if (preferencessoundprefvalue.text != "disabled") {PlaySound(relay ) };
                }
		sleep(1);
		if (preferencesTenSecondTickSoundPrefValue.text != "disabled") {
                  if (preferencessoundprefvalue.text != "disabled") {PlaySound(relay ) };
                }
		o.visible = true;
		sleep(5);
		o.visible = false;
		sleep(5);
		o.visible = true;
		sleep(5);
		o.visible = false;
		sleep(5);
		o.visible = true;
		sleep(5);
		o.visible = false;
		sleep(5);
		o.visible = true;
		if (preferencesTenSecondTickSoundPrefValue.text != "disabled") {
                  if (preferencessoundprefvalue.text != "disabled") {PlaySound(zzzz) };
                }
		if (preferencesTenSecondTickSoundPrefValue.text != "disabled") {
                  if (preferencessoundprefvalue.text != "disabled") {PlaySound(sparks) };
                }
	}

	function rattle2(o) {
		o.visible = false;
		sleep(1);
		if (preferencesTenSecondTickSoundPrefValue.text != "disabled") {
                  if (preferencessoundprefvalue.text != "disabled") {PlaySound(relay ) };
                }
		sleep(1);
		if (preferencesTenSecondTickSoundPrefValue.text != "disabled") {
                  if (preferencessoundprefvalue.text != "disabled") {PlaySound(relay ) };
                }
		o.visible = true;
		sleep(5);
		o.visible = false;
		sleep(5);
		o.visible = true;
		sleep(5);
		o.visible = false;
		sleep(5);
		o.visible = true;
		sleep(5);
		o.visible = false;
		sleep(5);
		o.visible = true;
		//(zzzz);
		if (preferencesTenSecondTickSoundPrefValue.text != "disabled") {
                  if (preferencessoundprefvalue.text != "disabled") {PlaySound(sparks ) };
                }
	}


function	setIndicatorFonts() {

	// normalise from variables to strings
	hour = String(hour);
	mins = String(mins);
	secs = String(secs);
        if (preferencesFontPrefValue.text != "mostra") {
           leftHourIndicator.src = WidgetPath + 'Resources/' + hour.substring(0, 1) + '.png';
        } else {
           leftHourIndicator.src = WidgetPath + 'Resources/' + hour.substring(0, 1) + 'G.png';
        }
        if (oldleftHourIndicator !== leftHourIndicator.src) {
		rattle(leftHourIndicator);
	}
        if (preferencesFontPrefValue.text != "mostra") {
	   rightHourIndicator.src = WidgetPath + 'Resources/' + hour.substring(1, 2) + '.png';
        } else {
	   rightHourIndicator.src = WidgetPath + 'Resources/' + hour.substring(1, 2) + 'G.png';
        }
       	if (oldrightHourIndicator !== rightHourIndicator.src) {
		rattle(rightHourIndicator);
	}
	oldleftHourIndicator = leftHourIndicator.src;
	oldrightHourIndicator = rightHourIndicator.src;

	//determine which number to display on the minutes
	if (mins.length < 2) {
		mins = "0" + mins;
	}
        if (preferencesFontPrefValue.text != "mostra") {
           leftMinuteIndicator.src = WidgetPath + 'Resources/' + mins.substring(0, 1) + '.png';
        } else {
           leftMinuteIndicator.src = WidgetPath + 'Resources/' + mins.substring(0, 1) + 'G.png';
        }
	if (oldleftMinuteIndicator !== leftMinuteIndicator.src) {
		rattle(leftMinuteIndicator);
	}
        if (preferencesFontPrefValue.text != "mostra") {
	    rightMinuteIndicator.src = WidgetPath + 'Resources/' + mins.substring(1, 2) + '.png';
	} else {
	    rightMinuteIndicator.src = WidgetPath + 'Resources/' + mins.substring(1, 2) + 'G.png';
        }
        if (oldrightMinuteIndicator !== rightMinuteIndicator.src) {
		rattle(rightMinuteIndicator);
	}

	oldleftMinuteIndicator = leftMinuteIndicator.src;
	oldrightMinuteIndicator = rightMinuteIndicator.src;

	if (preferencesSecondsShowPrefValue.text == "disabled") {
              return;
        }


	//determine which number to display on the seconds
	if (secs.length < 2) {
		secs = "0" + secs;
	}
        if (preferencesFontPrefValue.text != "mostra") {
           leftSecondIndicator.src = WidgetPath + 'Resources/' + secs.substring(0, 1) + '.png';
	} else {
           leftSecondIndicator.src = WidgetPath + 'Resources/' + secs.substring(0, 1) + 'G.png';
        }
	if (oldleftSecondIndicator !== leftSecondIndicator.src) {
		rattle2(leftSecondIndicator);
	}
        if (preferencesFontPrefValue.text != "mostra") {
	   rightSecondIndicator.src = WidgetPath + 'Resources/' + secs.substring(1, 2) + '.png';
	} else {
	   rightSecondIndicator.src = WidgetPath + 'Resources/' + secs.substring(1, 2) + 'G.png';
	}
        if (preferencesTickSoundPrefValue.text != "disabled") { PlaySound(zzzz) };

	oldleftSecondIndicator = leftSecondIndicator.src;
	oldrightSecondIndicator = rightSecondIndicator.src;
}


//==============================================================
// function to update the time
//==============================================================
function updateTime() {
	//initialise the time function
	
        var time = new Date(), timerInterval;

	//returns the date/time in a string format
	hour = time.getHours();
	mn = time.getMinutes();
	se = time.getSeconds();	// 0..59

	if (preferencesSecondsShowPrefValue.text == "disabled") {
 		timerInterval = 60 - se;	// 1..60 the interval to the next minute mark
		if (timerInterval > 10) { timerInterval -= 5; }
		clockTimer.setInterval = timerInterval;
	}

	returndateandtimevalues();

	//display the letters and numbers of the time
	updatecounters();

}
//=====================
//End function
//=====================



//===========================================
// this function opens other widgets URL
//===========================================
function otherwidgets() {
          if (confirm2("This button opens a browser window and connects to the Steampunk widgets page on my site. Do you wish to proceed?"))
          {
		openURL("http://lightquick.co.uk/steampunk-widgets.html?Itemid=264");
		if (preferencessoundprefvalue.text == "enabled") {
			PlaySound(winding);
		}
          }
}
//=====================
//End function
//=====================

//===========================================
// this function opens the URL for paypal
//===========================================
function donate() {
        if (confirm2("Help support the creation of more widgets like this, send us a beer! This button opens a browser window and connects to the Paypal donate page for this widget). Will you be kind and proceed?"))
        {
                openURL("https://www.paypal.com/cgi-bin/webscr?cmd=_xclick&business=info@lightquick.co.uk&currency_code=GBP&amount=2.50&return=&item_name=Donate%20a%20Beer");
		if (preferencessoundprefvalue.text === "enabled") {
			PlaySound(winding);
		}
	}
}
//=====================
//End function
//=====================

//===========================================
// this function opens my Amazon URL wishlist
//===========================================
function amazon() {
        if (confirm2("Help support the creation of more widgets like this. Buy me a small item on my Amazon wishlist! This button opens a browser window and connects to my Amazon wish list page). Will you be kind and proceed?"))
        {
		openURL("http://www.amazon.co.uk/gp/registry/registry.html?ie=UTF8&id=A3OBFB6ZN4F7&type=wishlist");
	}
}
//=====================
//End function
//=====================

//===========================================
// this function opens the rocketdock URL
//===========================================
function rocketdock() {
        if (confirm2("Log in and vote for my widgets on Rocketdock. This button opens a browser window and connects to the Rocketdock page where you can give the widget a 5 star rating... Will you be kind and proceed?"))
	{
		openURL("http://rocketdock.com/addon/icons/46779");
		if (preferencessoundprefvalue.text === "enabled") {
			PlaySound(winding);
		}
	}
}
//=====================
//End function
//=====================





//===========================================
// this function allows a spacer in the menu
//===========================================
function nullfunction() {
	print("dummy");
}
//=====================
//End function
//=====================


//=========================================================================
// this function closes the preferences
//=========================================================================
function button2OnClick(Sender)
{        if (preferencessoundprefvalue.text == "enabled") {PlaySound(tingingSound)};
         showWidgetPreferences.visible = false;
         widget.WindowZPosition=windowPos;

}
//=====================
//End function
//=====================



//=========================================================================
// this function shows the preferences when the first menu option is chosen
//=========================================================================
function menuitem8OnClick(Sender)
{
         windowPos = widget.WindowZPosition;
         showWidgetPreferences.top =  nixiewidget.top + 30;
         showWidgetPreferences.visible = true;
         widget.WindowZPosition=1;
         //widget.forceToFround();
         //widget.bringToFront();
}
//=====================
//End function
//=====================

//=========================================================================
// this function opens the online help file
//=========================================================================
function menuitem1OnClick() {
          if (confirm2("This button opens a browser window and connects to the help page for this widget. Do you wish to proceed?"))
          {
		openURL("http://lightquick.co.uk/instructions-for-the-steampunk-thermionic-nixie-tubes.html?Itemid=264");
          }
}
//=====================
//End function
//=====================

//=========================================================================
// this function opens the browser at the contact URL
//=========================================================================
function menuitem2OnClick() {
        if (confirm2("Visiting the support page - this button opens a browser window and connects to our contact us page where you can send us a support query or just have a chat). Proceed?"))
	{
		openURL("http://lightquick.co.uk/contact.html?Itemid=3");
		if (preferencessoundprefvalue.text == "enabled") {
			PlaySound(winding);
		}
	}
}
//=====================
//End function
//=====================

//=========================================================================
// this function reloads the widget - but it doesn't...
//=========================================================================
function menuitem9OnClick() {
         widget.ForceToFround();
         wsc.SendKeys("{f5}");
}
//=====================
//End function
//=====================



//=========================================================================
// this function opens the download URL
//=========================================================================
function update() {
        if (confirm2("Download latest version of the widget (this button opens a browser window and connects to the widget download page where you can check and download the latest zipped .WIDGET file). Proceed?"))
	{
		openURL("http://lightquick.co.uk/downloads/steampunk-thermionic-nixie-tube-xwidget.html?Itemid=264");
		if (preferencessoundprefvalue.text == "enabled") {
			PlaySound(winding);
		}
	}
}
//=====================
//End function
//=====================



//======================================================================================
// Function to move the main_window onto the main screen
//======================================================================================
function mainScreen() {
    // if the widget is off screen then move into the viewable window

    if (widget.left < 0) {
        widget.left = 10;
    }
    if (widget.top < 0) {
        widget.top = 10;
    }
}
//=====================
//End function
//=====================

//======================================================================================
// Function to perform commands
//======================================================================================
function performCommand() {
    print("preferencesImageCmdPrefValue.text "+preferencesImageCmdPrefValue.text);
    if ( preferencesImageCmdPrefValue.text == "" )
    {
        if (confirm2("This widget has not been assigned a double-click function yet - You need to open the preferences and set a function for this widget. Do you wish to proceed?"));
        {
                   showWidgetPreferences();
        }
    }
    if (preferencessoundprefvalue.text == "enabled") {PlaySound(tingingSound)};
    run(preferencesImageCmdPrefValue.text);
}
//=====================
//End function
//=====================


//=========================================================================
// this function sets the preference values to saved values
//=========================================================================
function getPrefs(){

    print ( "preferencessoundprefvalue.text "+ preferencessoundprefvalue.text);
    
    preferencesWidthPrefValue.percent =     Getinivalue(widgetpath+"prefs.ini","prefs","preferencesWidthPrefValue",100);
    preferencessoundprefvalue.text     = Getinivalue(widgetpath+"prefs.ini","prefs","","enabled");
    preferencesHour24PrefValue.text      = Getinivalue(widgetpath+"prefs.ini","prefs","preferencesHour24PrefValue","disabled");
    preferencesTenSecondTickSoundPrefValue.text       = Getinivalue(widgetpath+"prefs.ini","prefs","preferencesTenSecondTickSoundPrefValue","disabled");
    preferencesFontPrefValue.text        = Getinivalue(widgetpath+"prefs.ini","prefs","preferencesFontPrefValue","");
    preferencesSecondsShowPrefValue.text = Getinivalue(widgetpath+"prefs.ini","prefs","preferencesSecondsShowPrefValue","disabled");
    preferencesTickSoundPrefValue.text   = Getinivalue(widgetpath+"prefs.ini","prefs","preferencesTickSoundPrefValue","disabled");
    preferencesImageCmdPrefValue.text    = Getinivalue(widgetpath+"prefs.ini","prefs","preferencesImageCmdPrefValue","arseburgers");
    preferencesLicenceHideValue.text    = Getinivalue(widgetpath+"prefs.ini","prefs","preferencesLicenceHideValue","0");
    preferencesMouseWheelPrefValue.text =  Getinivalue(widgetpath+"prefs.ini","prefs","preferencesMouseWheelPrefValue","up");
    if (preferencessoundprefvalue.text != "disabled") {
        allSoundsButton.Checked = true;
    } else {
        allSoundsButton.Checked = false;
    }

    if (preferencesHour24PrefValue.text != "disabled") {
        use24ClockButton.Checked = true;
    } else {
        use24ClockButton.Checked = false;
    }

    if (preferencesTenSecondTickSoundPrefValue.text != "disabled") {
        enableTenSecondSoundsButton.Checked = true;
    } else {
        enableTenSecondSoundsButton.Checked = false;
    }

    if (preferencesSecondsShowPrefValue.text != "disabled") {
        showSecondsButton.Checked = true;
    } else {
        showSecondsButton.Checked = false;
    }

    if (preferencesTickSoundPrefValue.text != "disabled") {
        enableTickSoundsButton.Checked = true;
    } else {
        enableTickSoundsButton.Checked = false;
    }


}
//=====================
//End function
//=====================



//=========================================================================
// this function saves the preferences to an ini file for later use
//=========================================================================
function saveButtonOnClick(Sender)
{
         showWidgetPreferences.visible = false;
         if (preferencessoundprefvalue.text == "enabled") {PlaySound(electricDrone)};

         //print("preferencesFontPrefValue.text "+ preferencesFontPrefValue.text);
         SavePrefs();
         //print("preferencesFontPrefValue.text "+ preferencesFontPrefValue.text);
         widget.WindowZPosition=windowPos;
         widgetOnLoad();
}
//=====================
//End function
//=====================


//=========================================================================
// this saves the preferences
//=========================================================================
function SavePrefs ()
{
        print ( "preferencessoundprefvalue.text "+ preferencessoundprefvalue.text);
         Setinivalue(widgetpath+"prefs.ini","prefs","preferencesWidthPrefValue",preferencesWidthPrefValue.percent);
         Setinivalue(widgetpath+"prefs.ini","prefs","preferencessoundprefvalue",preferencessoundprefvalue.text);
         Setinivalue(widgetpath+"prefs.ini","prefs","preferencesHour24PrefValue",preferencesHour24PrefValue.text);
         Setinivalue(widgetpath+"prefs.ini","prefs","preferencesTenSecondTickSoundPrefValue",preferencesTenSecondTickSoundPrefValue.text);
         Setinivalue(widgetpath+"prefs.ini","prefs","preferencesFontPrefValue",preferencesFontPrefValue.text);
         Setinivalue(widgetpath+"prefs.ini","prefs","preferencesSecondsShowPrefValue",preferencesSecondsShowPrefValue.text);
         Setinivalue(widgetpath+"prefs.ini","prefs","preferencesTickSoundPrefValue",preferencesTickSoundPrefValue.text);
         Setinivalue(widgetpath+"prefs.ini","prefs","preferencesImageCmdPrefValue",preferencesImageCmdPrefValue.text);
         Setinivalue(widgetpath+"prefs.ini","prefs","preferencesLicenceHideValue",preferencesLicenceHideValue.text);

}
//=====================
//End function
//=====================


//=========================================================================
// this function opens the about us image
//=========================================================================
function menuitem11OnClick() {
         //print("here!");
         windowPos = widget.WindowZPosition;
         aboutUsImage.visible = true;
         widget.WindowZPosition=1;
}
//=====================
//End function
//=====================

//=========================================================================
// this function closes the about us image
//=========================================================================
function aboutUsImageOnClick() {
         widget.WindowZPosition=windowPos;
         aboutUsImage.visible = false;
}
//=====================
//End function
//=====================

//=========================================================================
// this function selects the Mostra font
//=========================================================================
function mostraButtonOnMouseDown() {
         print("preferencesFontPrefValue.text "+ preferencesFontPrefValue.Text);
         preferencesFontPrefValue.text = "mostra";
         print("preferencesFontPrefValue.text "+ preferencesFontPrefValue.Text);
         if (preferencessoundprefvalue.text == "enabled") {PlaySound(tingingSound)};

         setBgImage();
}
//=====================
//End function
//=====================

//=========================================================================
// this function selects the Arial arial font
//=========================================================================
function arialButtonOnMouseDown() {
         print("preferencesFontPrefValue.Text "+ preferencesFontPrefValue.Text);
         preferencesFontPrefValue.Text = "arial";
         //preferencesFontPrefValue.font.family = "Arial arial";
         print("preferencesFontPrefValue.text "+ preferencesFontPrefValue.Text);
         if (preferencessoundprefvalue.text == "enabled") {PlaySound(tingingSound)};
         setBgImage();
}
//=====================
//End function
//=====================


//=========================================================================
// this function sets the prefs for the 24hr clock
//=========================================================================
function setBgImage()
{
         if (preferencesFontPrefValue.text == "mostra") {
         bgimage1.src = WidgetPath + "Resources/nixiebg.png";
         bgimage2.src = WidgetPath + "Resources/nixiebg.png";
         bgimage3.src = WidgetPath + "Resources/nixiebg.png";
         bgimage4.src = WidgetPath + "Resources/nixiebg.png";
         bgimage5.src = WidgetPath + "Resources/nixiebg.png";
         bgimage6.src = WidgetPath + "Resources/nixiebg.png";
         } else {
         bgimage1.src = WidgetPath + "Resources/nixiebg.png";
         bgimage2.src = WidgetPath + "Resources/nixiebg.png";
         bgimage3.src = WidgetPath + "Resources/nixiebg.png";
         bgimage4.src = WidgetPath + "Resources/nixiebg.png";
         bgimage5.src = WidgetPath + "Resources/nixiebg.png";
         bgimage6.src = WidgetPath + "Resources/nixiebg.png";
         }
}
//=====================
//End function
//=====================

//=========================================================================
// this function sets the prefs for the 24hr clock
//=========================================================================
function use24ClockButtonOnMouseDown(Sender)
{
      if (use24ClockButton.Checked == -1 ) {
         preferencesHour24PrefValue.text = "enabled";
      } else {
         preferencesHour24PrefValue.text = "disabled";
      }
      if (use24ClockButton.Checked != 0 ) {
               if (preferencessoundprefvalue.text == "enabled") {PlaySound(tingingSound)};
      }
}
//=====================
//End function
//=====================


//=========================================================================
// this function sets the prefs for all the sounds
//=========================================================================
function allSoundsButtonOnMouseDown(Sender)
{
      if (allSoundsButton.Checked == -1 ) {
         preferencessoundprefvalue.text = "enabled";
      } else {
         preferencessoundprefvalue.text = "disabled";
      }

      if (allSoundsButton.Checked != 0 ) {
               //PlaySound(tingingSound);
               if (preferencessoundprefvalue.text == "enabled") {PlaySound(tingingSound)};
      }
}
//=====================
//End function
//=====================


//=========================================================================
// this function sets the prefs for storing the tick sounds ach second
//=========================================================================
function enableTickSoundsButtonOnMouseDown(Sender)
{
      if (enableTickSoundsButton.Checked == -1 ) {
         preferencesTickSoundPrefValue.text = "enabled";
      } else {
         preferencesTickSoundPrefValue.text = "disabled";
      }

      if (enableTickSoundsButton.Checked != 0 ) {
               //PlaySound(tingingSound);
               if (preferencessoundprefvalue.text === "enabled") {PlaySound(tingingSound)};
      }
}
//=====================
//End function
//=====================


//=========================================================================
// this function sets the prefs for storing the ten second tick sounds
//=========================================================================
function enableTenSecondSoundsButtonOnMouseDown(Sender)
{
      if (enableTenSecondSoundsButton.Checked == -1 ) {
         preferencesTenSecondTickSoundPrefValue.text = "enabled";
      } else {
         preferencesTenSecondTickSoundPrefValue.text = "disabled";
      }

      //preferencesTenSecondTickSoundPrefValue.text = enableTenSecondSoundsButton.Checked;
      if (enableTenSecondSoundsButton.Checked != 0 ) {
               //PlaySound(tingingSound);
               if (preferencessoundprefvalue.text === "enabled") {PlaySound(tingingSound)};
      }
}
//=====================
//End function
//=====================

//=========================================================================
// this function sets the prefs for howing the seconds tubes
//=========================================================================
function showSecondsButtonOnMouseDown(Sender)
{
      if (showSecondsButton.Checked == -1 ) {
         preferencesSecondsShowPrefValue.text = "enabled";
      } else {
         preferencesSecondsShowPrefValue.text = "disabled";
      }
      //preferencesSecondsShowPrefValue.text = showSecondsButton.Checked;
        if (preferencesSecondsShowPrefValue.text == "disabled") {
		leftSecondIndicator.visible = false;
                rightSecondIndicator.visible = false;
                bgimage5.visible = false;
                bgimage6.visible = false;
        } else {
		leftSecondIndicator.visible = true;
                rightSecondIndicator.visible = true;
                bgimage5.visible = true;
                bgimage6.visible = true;
        }
      if (showSecondsButton.Checked != 0 ) {
               //PlaySound(tingingSound);
               if (preferencessoundprefvalue.text === "enabled") {PlaySound(tingingSound)};
      }
}
//=====================
//End function
//=====================



//=========================================================================
// this function states the slider size in percentage in the little box on the prefs page
//=========================================================================
function preferencessizePrefvalueOnChange(Sender)
{    if (preferencessoundprefvalue.text == "enabled") {PlaySound(zzzz)};
     preferencesWidthPrefValue.percent ;
     preferencesWidthPrefValue.hint =     "The widget size will be "  + preferencesWidthPrefValue.percent + "%";
     widgetSize.text =     preferencesWidthPrefValue.percent +"%";
}
//=====================
//End function
//=====================




//===========================================
// this function captures the mouse wheel down event and resizes the clock
//===========================================
function nixiewidgetOnMouseWheelUp(Sender)
{
         //print("here! size "+size);
         size = Scale;
         step = Math.round((maxLength - minLength) / (ticks - 1));
	        if ( preferencesMouseWheelPrefValue.text == "up" ) {
                   size += step;
	           if (size > maxLength) {
	              size = maxLength;
	           }
                } else {
                   size -= step;
                   if (size < minLength) {
	               size = minLength;
                   }
                 }

     nixiewidget.scaleto(size/100,size/100,0.0000000001,"topleft");

     Scale = size;
     preferencesWidthPrefValue.percent = Scale;
}
//=====================
//End function
//=====================

//===========================================
// this function captures the mouse wheel down event and resizes the clock
//===========================================
function nixiewidgetOnMouseWheelDown(Sender)
{
         //print("here! size "+size);

         size = Scale;
         step = Math.round((maxLength - minLength) / (ticks - 1));
	        if ( preferencesMouseWheelPrefValue.text == "up" ) {
                   size -= step;
                   if (size < minLength) {
	               size = minLength;
                   }
                } else {
                   size += step;
	           if (size > maxLength) {
	              size = maxLength;
	           }
                }

     nixiewidget.scaleto(size/100,size/100,0.0000000001,"topleft");
     Scale = size;
     preferencesWidthPrefValue.percent = Scale;
}
//=====================
//End function
//=====================


//==============================================================
// function to resize all images using the volumeDevice single layer
//==============================================================
function resize() {

    if (preferencesWidthPrefValue.percent == 0) {preferencesWidthPrefValue.percent=34};
    print ("preferencesWidthPrefValue.percent " + preferencesWidthPrefValue.percent);
    //Scale = Number(preferencesWidthPrefValue.percent+5) / 100;

    //nixiewidget.scaleto(Scale,Scale,0.0000000001,"topleft");

     Scale = Number(preferencesWidthPrefValue.percent);
     nixiewidget.scaleto(Scale/100,Scale/100,0.0000000001,"topleft");

}
//=====================
//End function
//=====================


//=========================================================================
// this function ets the mouse schroll wheel to resize one way or another
//=========================================================================
function scrollButtonOnMouseDown(Sender,Button,Shift,X,Y)
{
        if (preferencesMouseWheelPrefValue.text === "up" ) {
               preferencesMouseWheelPrefValue.text = "down" ;
        } else {
               preferencesMouseWheelPrefValue.text = "up"  ;

        }
}
//=====================
//End function
//=====================


//=========================================================================
// this function makes the licence visible
//=========================================================================
function menuitem12OnClick(Sender)
{
     licence.Visible = true;
}
//=====================
//End function
//=====================


//=========================================================================
// this function
//=========================================================================
function DeclineOnClick (Sender,Button,Shift,X,Y)
{
        preferencesLicenceHideValue.text = "0";
        SavePrefs();
        widget.close
}
//=====================
//End function
//=====================


//=========================================================================
// this function
//=========================================================================
function AcceptOnClick(Sender,Button,Shift,X,Y)
{
  if (preferencessoundprefvalue.text === "enabled" ) {
      PlaySound(buzzer);    //this won't sound when the mute is set
  }
      preferencesLicenceHideValue.text = "1";
      licence.visible = false;
      SavePrefs();
}
//=====================
//End function
//=====================




//=========================================================================
// this function
//=========================================================================
function createLicence() {
	if (preferencesLicenceHideValue.text === "0") {
		licence.visible = true;
	} else {
		licence.visible   = false;
	}
}
//=====================
//End function
//=====================





       
//==============================
// pins the widget in place
//==============================
function rightHourIndicatorOnClick(Sender,Button,Shift,X,Y)
{
	print ("Sender.left " + Sender.left);
	print ("Sender.top " + Sender.top);
        lockWidget(Sender.left+X,Sender.top+Y);

};
//=====================
//End function
//=====================







//==============================
// unlocks the widget
//==============================
function pinOnMouseDown(Sender,Button,Shift,X,Y) {
	print ("Sender.left " + Sender.left);
	print ("Sender.top " + Sender.top);	
        lockWidget(Sender.left,Sender.top);
};
//==============================
//
//==============================



//======================================================================================
// Function to lock the widget
//======================================================================================
function lockWidget (hpos,vpos) {

    // check for aspect ratio and determine whether it is in portrait or landscape mode
    if (ScreenWidth > ScreenHeight) {
        aspectRatio = "landscape";
    } else {
        aspectRatio = "portrait";
    }

        print ( "widget.lockposition "+ widget.lockposition);
	if (widget.lockposition == -1 ) {
                pin.visible = 0;
                widget.lockposition = 0;

                // check if the widget has a lock for the screen type.
                if (aspectRatio == "landscape") {
		   preferenceswidgetLockLandscapeModePrefvalue.text = "disabled";
                }
                // check if the widget has a lock for the screen type.
                if (aspectRatio == "portrait") {
		   preferenceswidgetLockPortraitModePrefvalue.text = "disabled";
                }
                pin.hint="click me to lock the widget in place";
                rightHourIndicator.hint ="click this tube to lock the widget in place";
	        //screw2.tooltip="click me to lock the widget in place";
	        //paper.tooltip="";
	        //woodSurround.tooltip="";
	} else {
                pin.visible = true;
                widget.lockposition = -1;
                print ( "pin.left "+ pin.left);
                print ( "pin.top "+ pin.top);
                pin.left = hpos;
                pin.top = vpos ;

                // check if the widget has a lock for the screen type.
                if (aspectRatio == "landscape") {
		   preferenceswidgetLockLandscapeModePrefvalue.text = "enabled";
                   preferenceslandscapeHoffsetPrefvalue.text = widget.left ;
                   preferenceslandscapeVoffsetPrefvalue.text = widget.top ;
                }
                // check if the widget has a lock for the screen type.
                if (aspectRatio == "portrait") {
		   preferenceswidgetLockPortraitModePrefvalue.text = "enabled";
                   preferencesportraitHoffsetPrefvalue.text = widget.left ;
                   preferencesportraitVoffsetPrefvalue.text = widget.top ;
                }
	        pin.hint="click me to unlock";
                rightHourIndicator.hint="click me once to unlock the widget and then drag using the other tubes.";
                	         //screw2.tooltip="click me to unlock";
	         //paper.tooltip=woodSurround.tooltip="The widget is currently locked in place - click on the screw to release";
	         
        }
        if (preferencessoundprefvalue.text != "disabled" ) {PlaySound(lock);};

        print ( "preferencessoundprefvalue.text "+ preferencessoundprefvalue.text);
        print ( "widget.lockposition "+ widget.lockposition);
}
//=====================
//End function
//=====================




function switchOffFunctions(Sender)
{
      clockTimer.enabled = false;
}


function widgetOnEnter()
{
  prefsSaveTimer.enabled=true;
}

function widgetOnLeave()
{
  prefsSaveTimer.enabled=false;
}